from classes import *
from gain import *
import time

def tram():
    print("Nouvelle Partie")
    # Demande à l'utilisateur de répondre par Oui ou Non
    def repondre_oui_non(question):
        reponse = input(question)
        while reponse.lower() not in ["oui", "non"]:
            reponse = input("Répondre Oui/Non)\n")
        return reponse.lower() == "oui"
    
    separer = repondre_oui_non("Veux-tu jouer avec la règle permettant de séparer son jeu en 2 si les deux cartes tirées sont similaires ? (Répondre Oui/Non)\n-> ")
    doubler = repondre_oui_non("Veux-tu jouer avec la règle permettant de doubler sa mise en tirant une nouvelle carte après avoir reçu sa main, mais sans pouvoir retirer de carte ensuite ? (Répondre Oui/Non)\n-> ")
    abandonner = repondre_oui_non("Veux-tu jouer avec la règle permettant d'abandonner sa main après avoir vu son jeu et celui du croupier, et de récupérer la moitié de sa mise ? (Répondre Oui/Non)\n-> ")
    assurer = repondre_oui_non("Veux-tu jouer avec la règle permettant d'assurer sa mise lorsque la première carte du croupier est un As, et de récupérer sa mise si le croupier fait blackjack ? (Répondre Oui/Non)\n-> ")
    
    partie = Partie(separer, doubler, abandonner, assurer)
    partie.debutPartie()
    
    # Distribue les cartes initiales aux joueurs
    joueur = Joueur("Joueur")
    croupier = Joueur("Croupier")
    joueur.ajouter_carte(partie.paquet.distribuer())
    croupier.ajouter_carte(partie.paquet.distribuer())
    joueur.ajouter_carte(partie.paquet.distribuer())
    croupier.ajouter_carte(partie.paquet.distribuer())
    
    global premier_tour
    premier_tour = True
    
    # Affiche les cartes des joueurs
    print("\nTes cartes :")
    for carte in joueur.main:
        time.sleep(0.9)
        print(carte.getnom())
    time.sleep(0.9)
    print("\nTon score :",joueur.calculer_score())
    time.sleep(0.9)
    print("\n\nCartes du croupier :")
    time.sleep(0.9)
    print(croupier.main[0].getnom())
    time.sleep(0.9)
    print("Carte retournée\n\n")
    time.sleep(0.9)
    verif_gain(joueur, croupier, partie)

def verif_gain(joueur, croupier, partie):
    if joueur.calculer_score() == 21:
        joueur_gagne(joueur, croupier)
    if joueur.calculer_score() > 21:
        joueur_perd(joueur, croupier)
    if joueur.calculer_score() < 21:
        inferieur(joueur, croupier, partie)


        
def croupier_tire(croupier, partie):
    croupier.ajouter_carte(partie.paquet.distribuer())
    time.sleep(0.9)
    print("Le croupier à tiré un", croupier.main[-1].getnom(),".")
    time.sleep(0.9)
    print("Score du croupier :",croupier.calculer_score(),"\n")

def joueur_gagne(joueur, croupier):
    global premier_tour
    
    if joueur.calculer_score() == 21 and premier_tour == False:
        time.sleep(0.9)
        print("Bravo, tu as atteint 21. Tu as gagné !")
    elif joueur.calculer_score() == 21 and premier_tour == True:
        time.sleep(0.9)
        print("Blackjack ! Tu as gagné.")
        
    elif croupier.calculer_score() < joueur.calculer_score():
        time.sleep(0.9)
        print("Bravo, ta main est meilleure que celle du croupier. Tu as gagné !")
        
    elif croupier.calculer_score() > 21:
        time.sleep(0.9)
        print("Le croupier a dépassé 21. Bravo, tu as gagné !")
    
    premier_tour = False
        
    rejouer()


def joueur_perd(joueur, croupier):
    if joueur.calculer_score() > 21:
        time.sleep(0.9)
        print("Dommage, tu as dépassé 21, tu as donc perdu. Réessaye !")
    
    if croupier.calculer_score() > joueur.calculer_score():
        time.sleep(0.9)
        print("Dommage, la main du croupier est meilleure. Réessaye !")
        
    rejouer()

def egalite(joueur, croupier):
    time.sleep(0.9)
    print("Toi et le croupier avez le même score. Egalité !")
        
    rejouer()

def rejouer():
    time.sleep(0.9)
    rejouer = input("Veux tu rejouer ? Oui/Non\n-> ")
    if rejouer.lower() == "oui":
        time.sleep(0.9)
        for i in range(10):
            print("     ")
        tram()
    else:
        time.sleep(0.9)
        print("D'accord, merci d'avoir joué !")
    
tram()






