from classes import *
import time
import pygame as py



def tram():
    print("Nouvelle Partie")
    # Demande à l'utilisateur de répondre par Oui ou Non seulement
    def repondre_oui_non(question):
        reponse = input(question)
        while reponse.lower() not in ["oui", "non"]:
            reponse = input("Répondre Oui/Non)\n-> ")
        return reponse.lower() == "oui"
    
    separer = repondre_oui_non("Veux-tu jouer avec la règle permettant de séparer son jeu en 2 si les deux cartes tirées sont similaires ? (Répondre Oui/Non)\n-> ")
    doubler = repondre_oui_non("Veux-tu jouer avec la règle permettant de doubler sa mise en tirant une nouvelle carte après avoir reçu sa main, mais sans pouvoir retirer de carte ensuite ? (Répondre Oui/Non)\n-> ")
    abandonner = repondre_oui_non("Veux-tu jouer avec la règle permettant d'abandonner sa main après avoir vu son jeu et celui du croupier, et de récupérer la moitié de sa mise ? (Répondre Oui/Non)\n-> ")
    assurer = repondre_oui_non("Veux-tu jouer avec la règle permettant d'assurer sa mise lorsque la première carte du croupier est un As, et de récupérer sa mise si le croupier fait blackjack ? (Répondre Oui/Non)\n-> ")
    
    partie = Partie(separer, doubler, abandonner, assurer)
    partie.debutPartie()
    
    # Distribue les cartes initiales aux joueurs
    joueur = Joueur("Joueur")
    croupier = Joueur("Croupier")
    joueur.ajouter_carte(partie.paquet.distribuer())
    croupier.ajouter_carte(partie.paquet.distribuer())
    joueur.ajouter_carte(partie.paquet.distribuer())
    croupier.ajouter_carte(partie.paquet.distribuer())
    
    global premier_tour
    premier_tour = True
    
    # Affiche les cartes des joueurs
    print("\nTes cartes :")
    time.sleep(0.9)
    for carte in joueur.main:
        print(carte.getnom())
        time.sleep(0.7)
    time.sleep(0.2)
    print("\nTon score :",joueur.calculer_score())
    time.sleep(0.9)
    print("\n\nCartes du croupier :")
    time.sleep(0.9)
    print(croupier.main[0].getnom())
    time.sleep(0.7)
    print("Carte retournée\n\n")
    time.sleep(0.9)
    verif_gain(joueur, croupier, partie)

def verif_gain(joueur, croupier, partie):
    if joueur.calculer_score() == 21:
        joueur_gagne(joueur, croupier)
    if joueur.calculer_score() > 21:
        joueur_perd(joueur, croupier)
    if joueur.calculer_score() < 21:
        inferieur(joueur, croupier, partie)

def inferieur(joueur, croupier, partie):
    
    def repondre_bien(question):
        reponse = input(question)
        while reponse.lower() not in ["tirer", "rester", "separer"]:
            if question.lower() in "separer":    
                reponse = input("Répondre Tirer/Rester/Separer)\n-> ")
            else:
                reponse = input("Répondre Tirer/Rester)\n-> ")
        return reponse
    
    global premier_tour
    choix = ""
    time.sleep(0.9)
    if partie.separer == True:
        if joueur.calculer_score() == 20 or joueur.main[0].getvaleur() == joueur.main[1].getvaleur():
            if premier_tour == True:
                choix = repondre_bien("Ton score est inférieur à 21 et les valeurs de tes cartes sont identiques. Veux-tu tirer une nouvelle carte, rester à "+str(joueur.calculer_score())+" ou séparer ton jeu en 2 ? Tirer/Rester/Separer\n-> ")  
            else:
                choix = repondre_bien("Ton score est inférieur à 21. Veux-tu tirer une nouvelle carte ou rester à "+str(joueur.calculer_score())+"? Tirer/Rester\n-> ")
        else:
            choix = repondre_bien("Ton score est inférieur à 21. Veux-tu tirer une nouvelle carte ou rester à "+str(joueur.calculer_score())+"? Tirer/Rester\n-> ")
    premier_tour = False        
    if partie.separer == False:
        choix = repondre_bien("Ton score est inférieur à 21. Veux-tu tirer une nouvelle carte ou rester à "+str(joueur.calculer_score())+"? Tirer/Rester\n-> ")
    if choix.lower() == "separer":
        # Si l'option "séparer" est choisie, on crée deux mains distinctes pour le joueur
        main1 = [joueur.main[0], partie.paquet.distribuer()]
        main2 = [joueur.main[1], partie.paquet.distribuer()]
        joueur.mains = [main1, main2]
        time.sleep(0.9)
        print("\n\nTu as séparé ton jeu en 2 mains :")
        for i, main in enumerate(joueur.mains):
            """
            boucle "for" qui utilise la fonction "enumerate" pour récupérer à la fois l'indice de la main et la liste des cartes dans cette main.
            La variable "i" représente l'indice de la main, et la variable "main" représente la liste des cartes dans cette main.
            """
            time.sleep(0.9)
            print("\nMain", i+1, ":")
            for carte in main:
                print(carte.getnom())
        time.sleep(0.9)
    
    if choix.lower() == "tirer":
        joueur.ajouter_carte(partie.paquet.distribuer())
        time.sleep(0.9)
        print("Tu as tiré un", joueur.main[-1].getnom(),".")
        time.sleep(0.9)
        print("\nTes cartes :")
        for carte in joueur.main:
            print(carte.getnom())
        time.sleep(0.9)
        print("Ton score :",joueur.calculer_score(),"\n")
        time.sleep(0.9)
            
        
        if joueur.calculer_score() == 21:
            print("\nCartes du croupier :")
            for carte in croupier.main:
                time.sleep(0.9)
                print(carte.getnom())
            time.sleep(0.9)
            print("Score du croupier :",croupier.calculer_score(),"\n")
            time.sleep(0.9)
        verif_gain(joueur, croupier, partie)
    if choix.lower() == "rester":
        time.sleep(0.9)
        print("Tu as choisi de rester.\n")
        time.sleep(0.9)
        print("\nCartes du croupier :")
        for carte in croupier.main:
            time.sleep(0.9)
            print(carte.getnom())
        time.sleep(0.9)
        print("Score du croupier :",croupier.calculer_score(),"\n")
        time.sleep(0.9)
        print("Ton score :",joueur.calculer_score())
        
        while croupier.calculer_score() <= 16:
            croupier_tire(croupier, partie)
            
        if croupier.calculer_score() > 21:
            joueur_gagne(joueur, croupier)
        
        if croupier.calculer_score() > joueur.calculer_score():
            joueur_perd(joueur, croupier)
        if croupier.calculer_score() < joueur.calculer_score():
            joueur_gagne(joueur, croupier)
        if croupier.calculer_score() == joueur.calculer_score():
            egalite(joueur, croupier)
    return " "


def joueur_gagne(joueur, croupier):
    global premier_tour
    
    if joueur.calculer_score() == 21 and premier_tour == False:
        time.sleep(0.9)
        print("Bravo, tu as atteint 21. Tu as gagné !")
    elif joueur.calculer_score() == 21 and premier_tour == True:
        time.sleep(0.9)
        print("Blackjack ! Tu as gagné.")
        
    elif croupier.calculer_score() < joueur.calculer_score():
        time.sleep(0.9)
        print("Bravo, ta main est meilleure que celle du croupier. Tu as gagné !")
        
    elif croupier.calculer_score() > 21:
        time.sleep(0.9)
        print("Le croupier a dépassé 21. Bravo, tu as gagné !")
    
    premier_tour = False
        
    rejouer()


def joueur_perd(joueur, croupier):
    if joueur.calculer_score() > 21:
        time.sleep(0.9)
        print("Dommage, tu as dépassé 21, tu as donc perdu. Réessaye !")
    
    if croupier.calculer_score() > joueur.calculer_score():
        time.sleep(0.9)
        print("Dommage, la main du croupier est meilleure. Réessaye !")
        
    rejouer()


def egalite(joueur, croupier):
    time.sleep(0.9)
    print("Toi et le croupier avez le même score. Egalité !")
        
    rejouer()
        
def croupier_tire(croupier, partie):
    croupier.ajouter_carte(partie.paquet.distribuer())
    time.sleep(0.9)
    print("Le croupier à tiré un", croupier.main[-1].getnom(),".")
    time.sleep(0.9)
    print("Score du croupier :",croupier.calculer_score(),"\n")

def rejouer():
    time.sleep(0.9)
    rejouer = input("Veux tu rejouer ? Oui/Non\n-> ")
    if rejouer.lower() == "oui":
        time.sleep(0.9)
        for i in range(10):
            print("     ")
        tram()
    else:
        time.sleep(0.9)
        print("D'accord, merci d'avoir joué !")
    
#tram()